<?php

$themename = "Probama Theme";
$shortname = "Probama Theme";

if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3 class="widgettitle">',
        'after_title' => '</h3>',
    ));

// get_flickrRSS is adapted from http://eightface.com/wordpress/flickrrss/

function get_flickrRSS() {
	$default = '94975828@N00';
	$initialid = get_option('youtuber_youtubeid');

	# if there is no initial id, set the default id to Obama's official flick account id	
	if (!$initialid) {
		update_option('flickrRSS_flickrid', $default);
	}

	// the function can accept up to four parameters, otherwise it uses option panel defaults 	
  	for($i = 0 ; $i < func_num_args(); $i++) {
    	$args[] = func_get_arg($i);
    	}
  	if (!isset($args[0])) $num_items = get_option('flickrRSS_display_numitems'); else $num_items = $args[0];
  	if (!isset($args[1])) $tags = trim(get_option('flickrRSS_tags')); else $tags = trim($args[1]);
  	if (!isset($args[2])) $imagesize = get_option('flickrRSS_display_imagesize'); else $imagesize = $args[2];
  	if (!isset($args[3])) $userid = stripslashes(get_option('flickrRSS_flickrid')); else $userid = $args[3];

	if (!function_exists('MagpieRSS')) { // Check if another plugin is using RSS, may not work
		include_once (ABSPATH . WPINC . '/rss.php');
		error_reporting(E_ERROR);
	}


	// get the feed
	$rss_url = 'http://api.flickr.com/services/feeds/photos_public.gne?id=' . $userid . '&tags=' . $tags . '&format=rss_200';

	# get rss file
	$rss = @ fetch_rss($rss_url);

	if ($rss) {
    	$imgurl = "";
    	# specifies number of pictures
		$items = array_slice($rss->items, 0, $num_items);

	    # builds html from array
    	foreach ( $items as $item ) {
       	 if(preg_match('<img src="([^"]*)" [^/]*/>', $item['description'],$imgUrlMatches)) {
            	$imgurl = $imgUrlMatches[1];
 
            #change image size         
           	if ($imagesize == "square") {
             	$imgurl = str_replace("m.jpg", "s.jpg", $imgurl);
           	} elseif ($imagesize == "thumbnail") {
             $imgurl = str_replace("m.jpg", "t.jpg", $imgurl);
           	}
           
           $title = htmlspecialchars(stripslashes($item['title']));
           $url = $item['link'];
	
	       preg_match('<http://farm[0-9]{0,3}\.static.flickr\.com/\d+?\/([^.]*)\.jpg>', $imgurl, $flickrSlugMatches);
	       $flickrSlug = $flickrSlugMatches[1];
	       
         print "<li><a target=\"blank\" href=\"$url\" title=\"$title\"><img src=\"$imgurl\" alt=\"$title\" /></a></li>";      
       } // end pregmatch
     } // end foreach
  } else {
    #print "Flickr is having a massage (Flickr Blog)";
  }
} # end get_flickrRSS() function

function get_youtuber() {
	$default = 'jjXyqcx-mYY';
	$video = get_option('youtuber_youtubeid');

	# if there is no video yet, set the value to our default	
	if (!$video) {
		update_option('youtuber_youtubeid', $default);
		$video = get_option('youtuber_youtubeid');
	}
	
	print '<object type="application/x-shockwave-flash" style="width:332px; height:277px;" data="http://www.youtube.com/v/' . $video .'"><param name="movie" value="http://www.youtube.com/v/' . $video . '" /><param name="wmode" value="transparent"></param></object>';
}

function get_feedburner() {
	$default = 'Obama08AudioPodcast';
	$fbfeed = get_option('feedburner_feedburnerid');
	
	# if there is no feedburner stream yet, set the value to our default
	if (!$fbfeed) {
		update_option('feedburner_feedburnerid', $default);
		$fbfeed = get_option('feedburner_feedburnerid');
	}
	
	$base_url = 'http://feeds.feedburner.com/';
	$feed_url = $base_url . $fbfeed;
	
	print $feed_url;
}

function probama_subpanel() {
	if (isset($_POST['save_flickrrss_options'])) {
       $option_flickrid = $_POST['flickr_nsid'];
       $option_tags = $_POST['tags'];
       $option_display_numitems = $_POST['display_numitems'];
       $option_display_imagesize = $_POST['display_imagesize'];
       update_option('flickrRSS_flickrid', $option_flickrid);
       update_option('flickrRSS_tags', $option_tags);
       update_option('flickrRSS_display_numitems', $option_display_numitems);
       update_option('flickrRSS_display_imagesize', $option_display_imagesize);
       ?> <div class="updated"><p>flickr option changes saved.</p></div> <?php
     }
     
	if (isset($_POST['save_youtuber_options'])) {
       $option_youtubeid = $_POST['youtube_id'];
       update_option('youtuber_youtubeid', $option_youtubeid);
       ?> <div class="updated"><p>YouTube option changes saved.</p></div> <?php
     }
	 
	if (isset($_POST['save_feedburner_options'])) {
       $option_feedburnerid = $_POST['feedburner_id'];
       update_option('feedburner_feedburnerid', $option_feedburnerid);
       ?> <div class="updated"><p>Feedburner option changes saved.</p></div> <?php
     }


	?>

	<div class="wrap">
		<h2>flickr Settings</h2>
		<form method="post">
		
		<fieldset class="options">
		<table>
		 <tr>
		  <td><p><strong><label for="flickr_nsid">User ID</label>:</strong></p></td>
	      <td><input name="flickr_nsid" type="text" id="flickr_nsid" value="<?php echo get_option('flickrRSS_flickrid'); ?>" size="20" />
        		Use the <a href="http://idgettr.com">idGettr</a> to find the id for another account.</td>
         </tr>
         <tr>
          <td><p><strong>Display:</strong></p></td>
          <td>
        	<select name="display_numitems" id="display_numitems">
		      <option <?php if(get_option('flickrRSS_display_numitems') == '1') { echo 'selected'; } ?> value="1">1</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '2') { echo 'selected'; } ?> value="2">2</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '3') { echo 'selected'; } ?> value="3">3</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '4') { echo 'selected'; } ?> value="4">4</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '5') { echo 'selected'; } ?> value="5">5</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '6') { echo 'selected'; } ?> value="6">6</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '7') { echo 'selected'; } ?> value="7">7</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '8') { echo 'selected'; } ?> value="8">8</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '9') { echo 'selected'; } ?> value="9">9</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '10') { echo 'selected'; } ?> value="10">10</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '11') { echo 'selected'; } ?> value="11">11</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '12') { echo 'selected'; } ?> value="12">12</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '13') { echo 'selected'; } ?> value="13">13</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '14') { echo 'selected'; } ?> value="14">14</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '15') { echo 'selected'; } ?> value="15">15</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '16') { echo 'selected'; } ?> value="16">16</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '17') { echo 'selected'; } ?> value="17">17</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '18') { echo 'selected'; } ?> value="18">18</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '19') { echo 'selected'; } ?> value="19">19</option>
		      <option <?php if(get_option('flickrRSS_display_numitems') == '20') { echo 'selected'; } ?> value="20">20</option>
		      </select>
            <select name="display_imagesize" id="display_imagesize">
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'square') { echo 'selected'; } ?> value="square">square</option>
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'thumbnail') { echo 'selected'; } ?> value="thumbnail">thumbnail</option>
		      <option <?php if(get_option('flickrRSS_display_imagesize') == 'small') { echo 'selected'; } ?> value="small">small</option>
		    </select>
            <label for="mediumImages">images</label></p>
           </td> 
         </tr>
         <tr>
		  <td><p><strong><label for="tag">Tags:</label></strong></p></td>
          <td><input name="tags" type="text" id="tags" value="<?php echo get_option('flickrRSS_tags'); ?>" size="40" /> Comma separated, no spaces</p>
         </tr>
         </table>
        </fieldset>

		<p><div class="submit"><input type="submit" name="save_flickrrss_options" value="<?php _e('Save Options', 'save_flickrrss_options') ?>"  style="font-weight:bold;" /></div></p>
        </form>
        
        <h2>YouTube Settings</h2>
		<form method="post">
		
		<fieldset class="options">
		<table>
		 <tr>
		  <td><p><strong><label for="youtube_id">Video ID</label>:</strong></p></td>
	      <td><input name="youtube_id" type="text" id="youtube_id" value="<?php echo get_option('youtuber_youtubeid'); ?>" size="20" />
        		Example: 'Q2pXElHV6FA' in the URL http://youtube.com/watch?v=Q2pXElHV6FA</td>
         </tr>
         </table>
        </fieldset>

		<p><div class="submit"><input type="submit" name="save_youtuber_options" value="<?php _e('Save Options', 'save_youtuber_options') ?>"  style="font-weight:bold;" /></div></p>
        </form>
		
		<h2>Feedburner Podcast Settings</h2>
		<form method="post">
		
		<fieldset class="options">
		<table>
		 <tr>
		  <td><p><strong><label for="feedburner_id">Feedburner Podcast ID</label>:</strong></p></td>
	      <td><input name="feedburner_id" type="text" id="feedburner_id" value="<?php echo get_option('feedburner_feedburnerid'); ?>" size="20" />
        		Example: 'Obama08AudioPodcast' in the URL http://feeds.feedburner.com/Obama08AudioPodcast</td>
         </tr>
         </table>
        </fieldset>

		<p><div class="submit"><input type="submit" name="save_feedburner_options" value="<?php _e('Save Options', 'save_feedburner_options') ?>"  style="font-weight:bold;" /></div></p>
        </form>          
      
    </div>

<?php } // end probama_subpanel()

function probama_admin_menu() {
   if (function_exists('add_theme_page')) {
        add_theme_page('', 'Probama Options', 8, basename(__FILE__), 'probama_subpanel');
        }
}

// let's run our functions in a buffer to establish defaults when the admin panel is first run

ob_start();
get_flickrRSS();
get_youtuber();
get_feedburner();
ob_end_clean();

// and finally, let's add the admin menu

add_action('admin_menu', 'probama_admin_menu'); 

?>